/*
Drawboard - Java applet used to make graphical teleconferences
Copyright (C) 2001  Tomek "TomasH" Zielinski, tomash@fidonet.org.pl

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package drawboard;


// =============================================================================
// Alphabet definition class
//
// based on Arial bold 9 point
//
public class Alphabet {

  Alphabet(){
    System.out.println("Alphabet loaded");
  }

  static int[][] getLetter(char ch){
    switch (ch){
      case 'a': return a;
      case 'b': return b;
      case 'c': return c;
      case 'd': return d;
      case 'e': return e;
      case 'f': return f;
      case 'g': return g;
      case 'h': return h;
      case 'i': return i;
      case 'j': return j;
      case 'k': return k;
      case 'l': return l;
      case 'm': return m;
      case 'n': return n;
      case 'o': return o;
      case 'p': return p;
      case 'q': return q;
      case 'r': return r;
      case 's': return s;
      case 't': return t;
      case 'u': return u;
      case 'v': return v;
      case 'w': return w;
      case 'x': return x;
      case 'y': return y;
      case 'z': return z;

      case 'A': return A;
      case 'B': return B;
      case 'C': return C;
      case 'D': return D;
      case 'E': return E;
      case 'F': return F;
      case 'G': return G;
      case 'H': return H;
      case 'I': return I;
      case 'J': return J;
      case 'K': return K;
      case 'L': return L;
      case 'M': return M;
      case 'N': return N;
      case 'O': return O;
      case 'P': return P;
      case 'Q': return Q;
      case 'R': return R;
      case 'S': return S;
      case 'T': return T;
      case 'U': return U;
      case 'V': return V;
      case 'W': return W;
      case 'X': return X;
      case 'Y': return Y;
      case 'Z': return Z;

      case '1': return _1;
      case '2': return _2;
      case '3': return _3;
      case '4': return _4;
      case '5': return _5;
      case '6': return _6;
      case '7': return _7;
      case '8': return _8;
      case '9': return _9;
      case '0': return _0;
      case '@': return at;
      case '=': return equal;
      case '+': return plus;
      case '-': return minus;
      case ',': return comma;
      case '.': return dot;
      case '!': return shout;
      case '#': return hash;
      case '$': return dollar;
      case '%': return percent;
      case '^': return power;
      case '&': return amper;
      case '(': return leftbr;
      case ')': return rightbr;
      case ';': return commax;
      case ':': return dotx;
      case '\'': return apos;
      case '"': return quote;
      case '?': return ask;
      case '/': return slash;
      case '\\': return backslash;
      case '|': return pipe;
      case '`': return backapo;
      case '~': return tylde;
      case '<': return less;
      case '>': return more;
      case '[': return leftq;
      case ']': return rightq;
      case '{': return lefts;
      case '}': return rights;
      case '*': return star;
      case '_': return _under;
    };
    return space;
  }

  static int getWidth(char c){

    // Those characters looks better without trailing pixel column
    if (c=='f' || c=='c' || c=='r') return getLetter(c)[0].length-1;

    return getLetter(c)[0].length;
  }


  static int a[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,1,1,0},
    {1,0,0,0,1,1},
    {0,0,0,1,1,1},
    {0,1,1,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int b[][]={
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,1,1,0},
    {1,1,1,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,1,0,1,1},
    {1,1,0,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int c[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int d[][]={
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,1,1,0,1,1},
    {1,1,0,1,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,1,1,1},
    {0,1,1,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };


  static int e[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,1,1,1,1},
    {1,1,0,0,0,0},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };


  static int f[][]={
    {0,0,1,1,1},
    {0,1,1,0,0},
    {1,1,1,1,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0}
  };

  static int g[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,0,1,1},
    {1,1,0,1,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,1,1,1},
    {0,1,1,0,1,1},
    {1,0,0,0,1,1},
    {0,1,1,1,1,0}
  };

  static int h[][]={
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,1,1,0},
    {1,1,1,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int i[][]={
    {1,1},
    {0,0},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {0,0},
    {0,0}
  };

  static int j[][]={
    {0,1,1,},
    {0,0,0,},
    {0,1,1,},
    {0,1,1,},
    {0,1,1,},
    {0,1,1,},
    {0,1,1,},
    {0,1,1,},
    {0,1,1,},
    {0,1,1,},
    {1,1,0,}
  };

  static int k[][]={
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,1,1},
    {1,1,0,1,1,0},
    {1,1,1,1,0,0},
    {1,1,1,1,1,0},
    {1,1,0,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int l[][]={
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {0,0},
    {0,0}
  };

  static int m[][]={
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {1,1,0,1,1,1,0,1,1,0},
    {1,1,1,0,1,1,1,0,1,1},
    {1,1,0,0,1,1,0,0,1,1},
    {1,1,0,0,1,1,0,0,1,1},
    {1,1,0,0,1,1,0,0,1,1},
    {1,1,0,0,1,1,0,0,1,1},
    {1,1,0,0,1,1,0,0,1,1},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0}
  };

  static int n[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {1,1,0,1,1,0},
    {1,1,1,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int o[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int p[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {1,1,0,1,1,0},
    {1,1,1,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,1,0,1,1},
    {1,1,0,1,1,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0}
  };

  static int q[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,0,1,1},
    {1,1,0,1,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,1,1,1},
    {0,1,1,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1}
  };

  static int r[][]={
    {0,0,0,0},
    {0,0,0,0},
    {1,1,1,1},
    {1,1,0,0},
    {1,1,0,0},
    {1,1,0,0},
    {1,1,0,0},
    {1,1,0,0},
    {1,1,0,0},
    {0,0,0,0},
    {0,0,0,0}
  };

  static int s[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,1,0,0,0},
    {0,1,1,1,1,0},
    {0,0,1,1,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int t[][]={
    {0,0,1,0},
    {0,1,1,0},
    {1,1,1,1},
    {0,1,1,0},
    {0,1,1,0},
    {0,1,1,0},
    {0,1,1,0},
    {0,1,1,0},
    {0,0,1,1},
    {0,0,0,0},
    {0,0,0,0}
  };

  static int u[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,1,1,1},
    {0,1,1,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int v[][]={
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {0,0,1,1,1,0,0},
    {0,0,1,1,1,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int w[][]={
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {1,1,0,0,1,0,0,1,1},
    {1,1,0,1,1,1,0,1,1},
    {1,1,0,1,1,1,0,1,1},
    {0,1,0,1,0,1,0,1,0},
    {0,1,1,1,0,1,1,1,0},
    {0,1,1,1,0,1,1,1,0},
    {0,1,1,0,0,0,1,1,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0}
  };

  static int x[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,1,1,0,0},
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int y[][]={
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {0,0,1,1,1,0,0},
    {0,0,1,1,1,0,0},
    {0,0,1,1,0,0,0},
    {1,1,1,0,0,0,0}
  };

  static int z[][]={
    {0,0,0,0,0},
    {0,0,0,0,0},
    {1,1,1,1,1},
    {0,0,0,1,1},
    {0,0,1,1,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {1,1,0,0,0},
    {1,1,1,1,1},
    {0,0,0,0,0},
    {0,0,0,0,0}
  };


  static int _1[][]={
    {0,0,1,1},
    {0,1,1,1},
    {1,1,1,1},
    {1,0,1,1},
    {0,0,1,1},
    {0,0,1,1},
    {0,0,1,1},
    {0,0,1,1},
    {0,0,1,1},
    {0,0,0,0},
    {0,0,0,0}
  };

  static int _2[][]={
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,1,1,0},
    {0,0,1,1,0,0},
    {0,1,1,0,0,0},
    {1,1,0,0,0,0},
    {1,1,1,1,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _3[][]={
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,1,1,1,0},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _4[][]={
    {0,0,0,1,1,0},
    {0,0,1,1,1,0},
    {0,0,1,1,1,0},
    {0,1,0,1,1,0},
    {0,1,0,1,1,0},
    {1,0,0,1,1,0},
    {1,1,1,1,1,1},
    {0,0,0,1,1,0},
    {0,0,0,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _5[][]={
    {0,1,1,1,1,1},
    {0,1,1,0,0,0},
    {1,1,0,0,0,0},
    {1,1,1,1,1,0},
    {1,1,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _6[][]={
    {0,0,1,1,1,0},
    {0,1,0,0,1,1},
    {1,1,0,0,0,0},
    {1,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _7[][]={
    {1,1,1,1,1,1},
    {0,0,0,0,1,1},
    {0,0,0,1,1,0},
    {0,0,0,1,1,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,1,1,0,0,0},
    {0,1,1,0,0,0},
    {0,1,1,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _8[][]={
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _9[][]={
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,1},
    {0,0,0,0,1,1},
    {1,1,0,0,1,0},
    {0,1,1,1,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int _0[][]={
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int space[][]={
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0}
  };


  static int equal[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {1,1,1,1,1,1},
    {0,0,0,0,0,0},
    {1,1,1,1,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int plus[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {1,1,1,1,1,1},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int minus[][]={
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {1,1,1,1,1},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0}
  };

  static int dot[][]={
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {1,1},
    {1,1},
    {0,0},
    {0,0}
  };


  static int comma[][]={
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {1,1},
    {1,1},
    {0,1},
    {1,0}
  };

  static int slash[][]={
    {0,0,1},
    {0,0,1},
    {0,1,0},
    {0,1,0},
    {0,1,0},
    {0,1,0},
    {0,1,0},
    {1,0,0},
    {1,0,0},
    {0,0,0},
    {0,0,0}
  };

  static int ask[][]={
    {0,1,1,1,1,0},
    {1,1,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,1,1,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,0,0,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int shout[][]={
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {0,0},
    {1,1},
    {1,1},
    {0,0},
    {0,0}
  };

  static int at[][]={
    {0,0,0,1,1,1,1,1,0,0,0},
    {0,0,1,1,0,0,0,0,1,1,0},
    {0,1,0,0,1,1,0,1,1,1,1},
    {0,1,0,1,1,1,1,1,0,0,1},
    {1,0,1,1,0,0,1,1,0,0,1},
    {1,0,1,1,0,0,1,1,0,0,1},
    {1,0,1,1,0,0,1,1,0,1,0},
    {1,0,1,1,1,1,1,1,0,1,0},
    {1,0,0,1,1,0,1,1,1,0,1},
    {0,1,0,0,0,0,0,0,0,1,0},
    {0,0,1,1,1,1,1,1,1,0,0}
  };


  static int hash[][]={
    {0,0,1,0,0,1},
    {0,0,1,0,0,1},
    {1,1,1,1,1,1},
    {0,1,0,0,1,0},
    {0,1,0,0,1,0},
    {1,1,1,1,1,1},
    {0,1,0,0,1,0},
    {1,0,0,1,0,0},
    {1,0,0,1,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };


  static int dollar[][]={
    {0,0,1,0,0},
    {0,1,1,1,0},
    {1,0,1,0,1},
    {1,0,1,0,0},
    {1,1,1,0,0},
    {0,1,1,1,0},
    {0,0,1,1,1},
    {0,0,1,0,1},
    {1,0,1,0,1},
    {0,1,1,1,0},
    {0,0,1,0,0}
  };

  static int percent[][]={
    {1,1,1,0,0,1,0,0},
    {1,0,1,0,0,1,0,0},
    {1,0,1,0,1,0,0,0},
    {1,0,1,0,1,0,0,0},
    {1,0,1,0,1,1,1,1},
    {1,1,1,1,0,1,0,1},
    {0,0,0,1,0,1,0,1},
    {0,0,1,0,0,1,0,1},
    {0,0,1,0,0,1,1,1},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0}
  };

  static int power[][]={
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,1,1,1,1,0},
    {0,1,0,0,1,0},
    {1,1,0,0,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };


  static int amper[][]={
    {0,0,0,1,1,1,0,0},
    {0,0,1,1,0,1,1,0},
    {0,0,1,1,0,1,1,0},
    {0,0,0,1,1,1,0,0},
    {0,0,1,1,1,1,0,0},
    {1,1,0,1,1,0,1,1},
    {1,1,0,0,1,1,1,0},
    {1,1,0,0,1,1,1,1},
    {0,1,1,1,1,0,1,1},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0}
  };

  static int leftbr[][]={
    {0,0,1},
    {0,1,1},
    {0,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {0,1,0},
    {0,1,1},
    {0,0,1}
  };

  static int rightbr[][]={
    {1,0,0},
    {1,1,0},
    {0,1,0},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,0},
    {1,1,0},
    {1,0,0}
  };


  static int dotx[][]={
    {0,0},
    {0,0},
    {1,1},
    {1,1},
    {0,0},
    {0,0},
    {0,0},
    {1,1},
    {1,1},
    {0,0},
    {0,0}
  };


  static int commax[][]={
    {0,0},
    {0,0},
    {1,1},
    {1,1},
    {0,0},
    {0,0},
    {0,0},
    {1,1},
    {1,1},
    {0,1},
    {1,0}
  };

  static int apos[][]={
    {1,1},
    {1,1},
    {1,1},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0},
    {0,0}
  };

  static int quote[][]={
    {1,1,0,1,1},
    {1,1,0,1,1},
    {1,1,0,1,1},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0}
  };


  static int leftq[][]={
    {1,1,1},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,0},
    {1,1,1}
  };

  static int rightq[][]={
    {1,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {0,1,1},
    {1,1,1}
  };


  static int lefts[][]={
    {0,0,1,1,1},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {1,1,0,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,1,1,0,0},
    {0,0,1,1,1},
  };

  static int rights[][]={
    {1,1,1,0,0},
    {0,0,1,1,0},
    {0,0,1,1,0},
    {0,0,1,1,0},
    {0,0,1,1,0},
    {0,0,0,1,1},
    {0,0,1,1,0},
    {0,0,1,1,0},
    {0,0,1,1,0},
    {0,0,1,1,0},
    {1,1,1,0,0}
  };

  static int backslash[][]={
    {1,0,0},
    {1,0,0},
    {0,1,0},
    {0,1,0},
    {0,1,0},
    {0,1,0},
    {0,1,0},
    {0,0,1},
    {0,0,1},
    {0,0,0},
    {0,0,0}
  };

  static int pipe[][]={
    {1},
    {1},
    {1},
    {1},
    {1},
    {1},
    {1},
    {1},
    {1},
    {1},
    {1}
  };


  static int less[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,1},
    {0,0,0,1,1,1},
    {0,1,1,1,0,0},
    {1,1,0,0,0,0},
    {0,1,1,1,0,0},
    {0,0,0,1,1,1},
    {0,0,0,0,0,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int more[][]={
    {0,0,0,0,0,0},
    {1,0,0,0,0,0},
    {1,1,1,0,0,0},
    {0,0,1,1,1,0},
    {0,0,0,0,1,1},
    {0,0,1,1,1,0},
    {1,1,1,0,0,0},
    {1,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };


  static int backapo[][]={
    {1,1,0},
    {0,1,1},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0}
  };

  static int tylde[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,1,1,0,0,1},
    {1,0,0,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int star[][]={
    {0,1,0},
    {1,1,1},
    {0,1,0},
    {1,0,1},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0}
  };

  static int _under[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {1,1,1,1,1,1}
  };



  static int A[][]={
    {0,0,1,1,1,0,0},
    {0,0,1,1,1,0,0},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0},
    {1,1,1,1,1,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };


  static int B[][]={
    {1,1,1,1,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,1,1,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,1,1,1,1,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int C[][]={
    {0,0,1,1,1,1,0},
    {0,1,1,0,0,1,1},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {0,1,1,0,0,1,1},
    {0,0,1,1,1,1,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int D[][]={
    {1,1,1,1,1,0,0},
    {1,1,0,0,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,1,1,0},
    {1,1,1,1,1,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int E[][]={
    {1,1,1,1,1,1},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,1,1,1,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,1,1,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int F[][]={
    {1,1,1,1,1},
    {1,1,0,0,0},
    {1,1,0,0,0},
    {1,1,0,0,0},
    {1,1,1,1,1},
    {1,1,0,0,0},
    {1,1,0,0,0},
    {1,1,0,0,0},
    {1,1,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0}
  };

  static int G[][]={
    {0,0,1,1,1,1,0},
    {0,1,1,0,0,1,1},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {1,1,0,0,1,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,1,1,0,0,1,1},
    {0,0,1,1,1,1,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int H[][]={
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,1,1,1,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int I[][]={
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {1,1},
    {0,0},
    {0,0}
  };

  static int J[][]={
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {0,0,0,0,1,1},
    {1,1,0,0,1,1},
    {1,1,0,0,1,1},
    {0,1,1,1,1,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int K[][]={
    {1,1,0,0,0,1,1},
    {1,1,0,0,1,1,0},
    {1,1,0,1,1,0,0},
    {1,1,1,1,1,0,0},
    {1,1,1,1,1,1,0},
    {1,1,0,0,1,1,0},
    {1,1,0,0,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int L[][]={
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,1,1,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int M[][]={
    {1,1,1,0,0,0,1,1,1},
    {1,1,1,0,0,0,1,1,1},
    {1,1,1,1,0,1,1,1,1},
    {1,1,1,1,0,1,1,1,1},
    {1,1,0,1,0,1,0,1,1},
    {1,1,0,1,0,1,0,1,1},
    {1,1,0,1,0,1,0,1,1},
    {1,1,0,1,0,1,0,1,1},
    {1,1,0,0,1,0,0,1,1},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0}
  };


  static int N[][]={
    {1,1,0,0,0,1,1},
    {1,1,1,0,0,1,1},
    {1,1,1,0,0,1,1},
    {1,1,1,1,0,1,1},
    {1,1,0,1,0,1,1},
    {1,1,0,1,1,1,1},
    {1,1,0,0,1,1,1},
    {1,1,0,0,1,1,1},
    {1,1,0,0,0,1,1},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int O[][]={
    {0,0,1,1,1,1,0,0},
    {0,1,1,0,0,1,1,0},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {0,1,1,0,0,1,1,0},
    {0,0,1,1,1,1,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0}
  };

  static int P[][]={
    {1,1,1,1,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,1,1,1,1,0},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {1,1,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int Q[][]={
    {0,0,1,1,1,1,0,0},
    {0,1,1,0,0,1,1,0},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,0,0,1,1},
    {1,1,0,0,1,0,1,1},
    {0,1,1,0,0,1,1,0},
    {0,0,1,1,1,1,1,0},
    {0,0,0,0,0,0,0,1},
    {0,0,0,0,0,0,0,0}
  };

  static int R[][]={
    {1,1,1,1,1,1,0,0},
    {1,1,0,0,0,1,1,0},
    {1,1,0,0,0,1,1,0},
    {1,1,0,0,0,1,1,0},
    {1,1,1,1,1,1,1,0},
    {1,1,0,0,1,1,0,0},
    {1,1,0,0,0,1,1,0},
    {1,1,0,0,0,1,1,0},
    {1,1,0,0,0,0,1,1},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0}
  };

  static int S[][]={
    {0,1,1,1,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,0,0},
    {1,1,1,1,0,0,0},
    {0,1,1,1,1,1,0},
    {0,0,0,1,1,1,1},
    {0,0,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,1,1,1,1,1,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int T[][]={
    {1,1,1,1,1,1},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

  static int U[][]={
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,1,1,1,1,1,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int V[][]={
    {1,1,0,0,0,0,0,1,1},
    {0,1,1,0,0,0,1,1,0},
    {0,1,1,0,0,0,1,1,0},
    {0,1,1,0,0,0,1,1,0},
    {0,0,1,1,0,1,1,0,0},
    {0,0,1,1,0,1,1,0,0},
    {0,0,1,1,0,1,1,0,0},
    {0,0,0,1,1,1,0,0,0},
    {0,0,0,1,1,1,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0}
  };

  static int W[][]={
    {1,1,0,0,0,1,1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1,1,0,0,0,1,1},
    {0,1,1,0,1,1,1,1,1,0,1,1,0},
    {0,1,1,0,1,1,0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0,1,1,0,1,1,0},
    {0,1,1,0,1,1,0,1,1,0,1,1,0},
    {0,0,1,1,1,0,0,0,1,1,1,0,0},
    {0,0,1,1,1,0,0,0,1,1,1,0,0},
    {0,0,1,1,1,0,0,0,1,1,1,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0}
  };

  static int X[][]={
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,1,1,0,1,1,0},
    {0,1,1,1,1,1,0},
    {0,0,1,1,1,0,0},
    {0,1,1,1,1,1,0},
    {0,1,1,0,1,1,0},
    {1,1,0,0,0,1,1},
    {1,1,0,0,0,1,1},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int Y[][]={
    {1,1,0,0,0,0,1,1},
    {0,1,1,0,0,1,1,0},
    {0,1,1,0,0,1,1,0},
    {0,0,1,1,1,1,0,0},
    {0,0,0,1,1,0,0,0},
    {0,0,0,1,1,0,0,0},
    {0,0,0,1,1,0,0,0},
    {0,0,0,1,1,0,0,0},
    {0,0,0,1,1,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0}
  };

  static int Z[][]={
    {1,1,1,1,1,1},
    {0,0,0,0,1,1},
    {0,0,0,1,1,0},
    {0,0,1,1,0,0},
    {0,0,1,1,0,0},
    {0,1,1,0,0,0},
    {1,1,0,0,0,0},
    {1,1,0,0,0,0},
    {1,1,1,1,1,1},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };

}


/*
    Templates for 11 points height font

    int a[][]={
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0}
    };

  static int 5[][]={
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0},
    {0,0,0,0,0}
  };

  static int 6[][]={
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0},
    {0,0,0,0,0,0}
  };


  static int 7[][]={
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0}
  };

  static int 8[][]={
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0}
  };

  static int 9[][]={
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0}
  };

*/